package lib.print;

import java.awt.print.*;
import java.awt.geom.*; 
import java.awt.*;
import javax.swing.*;

class PagePanel extends JPanel {

	private TablePrint tablePrint;
	private PageFormat pageFormat;
	private int index;
	private int width;
	private int height;
	
	//    
	private Image image;
	
	//   
	private Graphics2D graphics;
	
	//      false     :
	// 
	private boolean data;
	
	PagePanel(TablePrint tablePrint, PageFormat pageFormat, boolean data) {
		this.tablePrint = tablePrint;
		this.pageFormat = pageFormat;
		this.data = data;
		width = (int)pageFormat.getWidth();
		height = (int)pageFormat.getHeight();
		index = 0;
		setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
	}

	//   y
	void setPageIndex(int index) {
		this.index = index;
		if(graphics != null)
			updateImage();
		repaint();
	}
	
	public void paintComponent(Graphics g) {
		super.paintComponent(g);
		//    ,      
		if(graphics == null) {
			image = createImage(width,height);
			graphics = (Graphics2D)image.getGraphics();
			updateImage();
		}
			
		//  
		g.drawImage(image,10,10,this);
	}
	
	public Dimension getPreferredSize() {
		return new Dimension(width+20,height+20);
	}
	
	//     TablePrint
	private void updateImage() {
		graphics.setColor(Color.white);
		graphics.fillRect(0,0,width,height);
		graphics.setColor(Color.black);
		graphics.drawRect(0,0,width-1,height-1);
		
		//         y  : " !"
		if(!data) {
			String s = " ";
			FontMetrics fontMetrics = graphics.getFontMetrics();
			int heidthTex = fontMetrics.getHeight();
			int withString = fontMetrics.stringWidth(s);
			graphics.setColor(Color.red);
			graphics.setFont(new Font("Font.DIALOG",Font.BOLD,16));
			graphics.drawString(" !",(int)pageFormat.getWidth()/2 - withString/2,
			(int)pageFormat.getHeight()/2);
			} else 
			try{
				tablePrint.print(graphics,pageFormat,index);
		    }catch(PrinterException e) {;}
			
		//    
		graphics.setTransform(new AffineTransform());
	}
}