package lib.print;

import java.util.*;
import java.awt.*;
import java.awt.print.*;
import java.awt.geom.*; 
import javax.swing.*;
import javax.swing.table.*;

//              String
public class TablePrint implements Printable {
	
	//    
	private Vector<String> columnames;
	
	//    
	private Vector<Vector<String>> data;
	
	// ,       
	private String tableName;
	
	//   
	private int ImageableWidth;
	
	//   
	private int ImageableHeight;
	
	//     
	private AffineTransform affineTransform;
	
	//   X    
	private Vector<Integer> printX;
	
	//  
	private int heidthTex;
	
	// Y    
	private int position;
	
	//  
	int maxIndex;
	
	//  ,  false     
	private boolean revers;
	
	//    
	private boolean flag;
	
	/*     
		  
		: owner -     ,  null
		tableData     
		tableName  ,     ,  null   
		  : null
		
		screen-     ,  true   
		        
	*/
	public void print(Frame owner,TableData tableData, String tableName, boolean screen) {
		
		//   
		columnames = tableData.getVectorColumnNames();
		
		//  
		data = tableData.getVectorData();
		
		//  
		this.tableName = tableName;
		
		//  PrinterJob
		PrinterJob printer = PrinterJob.getPrinterJob();
		
		//     
		//    ""      
		PageFormat p,pageFormat = new PageFormat();
		if(pageFormat == (p = printer.pageDialog(pageFormat))) return;
			pageFormat = p;
		
		//    
		ImageableWidth = (int)(pageFormat.getImageableWidth());
		ImageableHeight = (int)(pageFormat.getImageableHeight());
		float ImageableX = (float)pageFormat.getImageableX();
		float ImageableY = (float)pageFormat.getImageableY();
		
		//            
		// 
		affineTransform = new AffineTransform(1,0,0,1,ImageableX,ImageableY);
		
		//   
		flag = true;
		
		//   
		revers = true;
		
		// screen true          
		int n = 1;
		if(screen)
			if((n = ScreenPrint.show(owner,this,p)) == ScreenPrint.CANCEL)
				return;
				
		//         false
		if(n == ScreenPrint.REVERSE)
			revers = false;
		
		//   ,     
		//     printX       
		//             
		if(screen)
			flag = true ;
			
		//       
		printer.setPrintable(this, pageFormat);
		
		//  
		try {
			printer.print();
		}catch (PrinterException e) {
			//     
			JOptionPane.showMessageDialog(owner, "   ",
			"", JOptionPane.ERROR_MESSAGE);
		}
	}
	
	//   Printable
	public int print(Graphics g, PageFormat pageFormat,int index) throws PrinterException { 
	
	    //   
		 Graphics2D g_2 = (Graphics2D)g;
		 
	    //          X   ,   ,
		//  
		if(flag) {
		
		 // 
		 g_2.setFont(new Font("Font.DIALOG",Font.PLAIN,12));
		 
		 //  FontMetrics 
		 FontMetrics fontMetrics = g_2.getFontMetrics();
		 
		 //  
		 heidthTex = fontMetrics.getHeight();

		 //      ,     maxPageIndex(
		 //    
	     int n_1 = (ImageableHeight-(heidthTex*2 + heidthTex/4 + heidthTex/4))/heidthTex;
			
		 //       
		 int n_2 = data.size()/n_1;
			
		 //   
		 int n_3 = data.size()%n_1;
			
		 //   
		 maxIndex = n_2 + (n_3 > 0 ? 1 : 0) - 1;
		
		 //  
		 printX = new Vector();

		 //        
		 //         
		 for(String s: columnames)
			printX.add(fontMetrics.stringWidth(s));
			
		 //     
		 for(int i_1 = 0;i_1 < data.size();i_1 ++)
			 for(int i_2 = 0 ;i_2 < data.get(i_1).size();i_2 ++)
				 if (fontMetrics.stringWidth(data.get(i_1).get(i_2))>printX.get(i_2))
					 printX.set(i_2,fontMetrics.stringWidth(data.get(i_1).get(i_2)));
					 
		 //           
		    for(int i = 0;i < printX.size();i ++)
				printX.set(i, printX.get(i) + heidthTex *2);
		 
		 //   
		 int maxSum = 0;
		 for(int m : printX)
			 maxSum += m;
			
		 //            
		 //      
		 if(maxSum < ImageableWidth)
			 for(int i = 0; i < printX.size(); i ++)
				 printX.set(i,printX.get(i)+(ImageableWidth - maxSum)/printX.size());
		 //       
		 else {
			int k = 0;
			for(int i = 0; i < printX.size();) {
				k +=printX.get(i);
				if(k > ImageableWidth)
					printX.remove(i);
				else
					i++ ;
			}
		}
		
		 //   printX     X
		 for(int i = 0; i < printX.size(); i++)
			 if(i == 0)
				 printX.insertElementAt(0,0);
			 else
				 printX.set(i, printX.get(i) + printX.get(i-1));
					
		 //    
         printX.remove(printX.size()-1);
		 
		 //   Y    
		 position = heidthTex*3 + heidthTex/4 + heidthTex/4;
			
		 //   false        
		 flag = false;
		}
		 //     
		 if(!revers)
			 index = maxIndex - index;
		
		 //         
		  if(index > maxIndex || index < 0)
			 return Printable.NO_SUCH_PAGE;
			 
		 //     
	     g_2.transform(affineTransform);
		 
		 //     
		 g_2.drawString(tableName + "  : " + (index + 1) 
			+ "  " + (maxIndex + 1),0, heidthTex);
		 
		 //  
		 for(int i = 0;i < printX.size();i ++)
			g_2.drawString(columnames.get(i),printX.get(i),heidthTex*2);
			
		//   
		g_2.fillRect(0,(heidthTex*2+heidthTex/4),ImageableWidth, heidthTex/4);
		
		//      ,        
		//        
		int nextRow =(ImageableHeight-(heidthTex*2 + heidthTex/4 + heidthTex/4))/heidthTex*index;
		
		//  position   
		int p = position;
		for(;nextRow < data.size() && p <= ImageableHeight;nextRow ++, p += heidthTex)
			for(int i = 0; i < printX.size(); i++)
			  g_2.drawString(data.get(nextRow).get(i),printX.get(i),p);
			  
		//   
		return Printable.PAGE_EXISTS;
	}
	
	//    .         -1
	//16 -    DIALOG, 40  
	public int maxPageIndex() {
	
		//         -1
		if(columnames.size() == 0)
			return -1;
			
		//  data      -1
		for(Vector<String> v : data)
			if(v.size() == 0)
				return -1;
				
		//    data     -1
		return data.size()/((ImageableHeight-40)/16) -1 
			+ (data.size()%((ImageableHeight-40)/16) > 0 ? 1 : 0);
	}
	
	//  
	public static void main(String[] args) {
		//  TablePrint  
		TablePrint tablePrint = new TablePrint();
		
		//   
		Vector<String> colunNames = new Vector();
		colunNames.add("  0  99");
		
		//  
		Vector<Vector<String>> d = new Vector();
		Vector<String> v = new Vector();
		
		for( int i = 0; i < 100;d.add(v),v = new Vector(),i++)
			v.add(i + "");
			
		//  TablePrintData
		TablePrintData t = new TablePrintData(colunNames, d);
		
		// 
		tablePrint.print(null, t, "", true);
	}
}